C---------------------------------------------------------------------------------
C     PROGRAM TO CREATE ONE-DIMENSIONAL ELECTRON DENSITIES FROM THE 3D
C     MEM DENSITIES CREATED BY THE PRIMA (MEM PROGRAM) OF 
C     RUBEN A. DILANIAN AND FUJIO IZUMI.ADVANCED MATERIALS LABORATORY,
C     NATIONAL INSTITUTE FOR MATERIALS SCIENCE, 1-1 NAMIKI, TSUKUBA, 
C     IBARAKI 305-0044, JAPAN
C     BY DR. R. SARAVANAN, LECTURER, THE MADURA COLLEGE, MADURAI, INDIA
C     WEBSITE: WWW.SARAXRAYGROUP.NET; EMAIL: SARAGOW@DATAONE.IN
C----------------------------------------------------------------------------------
C     INPUT FILE NAME IS INDEN
C     THIS FILE CONTAINS THE OUTPUT (*.DEN) OF THE MEM PROGRAM PRIMA
C     *.DEN FILE CAN BE CREATED FROM THE PREFERENCE FILE *.PRF, BY 
C     SETTING THE NAME OF THE 3D DENSITY FILE AS *.DEN AND RUNNING 
C     THE BATCH FILE *.BAT
C     THIS *.DEN FILE IS APPENDED BY THE NUMBER OF SYMMETRY CARDS AND 
C     THE FULL SYMMETRY CARDS (ROTATIONAL AND TRANSLATIONAL IN SPECIFIED FORAMT)
C----------------------------------------------------------------------------------
C 1.  FIRST EDIT THE PREFERENCE FILE *.PRF
C 2.  SET THE ELECTRON DENSITY FILE NAME AS *.DEN
C 3.  RUN SUCCESSFULLY THE BATCH FILE (CONTAINING "%PRIMA%PRIMA.exe" FILE_NAME.prf)
C 4.  THE *.DEN FILE WILL BE CREATED WITH OTHER OUTPUTS
C 5.  USE THIS FILE APPENDED WITH SYMMETRY CARDS AS GIVEN IN THE EXAMPLE
C-----------------------------------------------------------------------------------
      DIMENSION TITLE(20),IASYM(3,90000),CELL(6),NPIX(3),ISUB(10,10),
     *RDEN(90000),AIASYM(3,90000),R(192,9),T(192,3),RL(192,9),XJX(129,
     *129,129),IIR(192,9),IIT(192,3),RR(192,9),TR(192,3)
       INTEGER KX(129,129,129)
       OPEN(2,FILE='INDEN')
       OPEN(3,FILE='CHECK')
       OPEN(4,FILE='100')
       OPEN(7,FILE='010')
       OPEN(8,FILE='001')
       OPEN(9,FILE='110')
       OPEN(10,FILE='011')
       OPEN(11,FILE='101')
       OPEN(12,FILE='111')
       PHI=3.141592
       READ(2,22)(TITLE(I1),I1=1,20)
       WRITE(3,22)(TITLE(I1),I1=1,20)
22     FORMAT(20A4)
       READ(2,23)NASYM
       WRITE(3,23)NASYM
23     FORMAT(I8)
       READ(2,24)((IASYM(I2,J),I2=1,3),RDEN(J),(IASYM(I2,J+1),I2=1,3),
     *RDEN(J+1),J=1,NASYM,2)
       WRITE(3,24)((IASYM(I2,J),I2=1,3),RDEN(J),(IASYM(I2,J+1),I2=1,3),
     *RDEN(J+1),J=1,NASYM,2)
24     FORMAT(2(3I5,F20.13))
       READ(2,25)(CELL(I3), I3 = 1, 6)
       WRITE(3,25)(CELL(I3), I3 = 1, 6)
25     FORMAT(6F10.5)
       READ(2,26)(NPIX(I4),I4=1,3),NSYM,NCEN,NSUB
       WRITE(3,26)(NPIX(I4),I4=1,3),NSYM,NCEN,NSUB
26     FORMAT(6I5)
       NPX1=NPIX(1)
       NPX2=NPIX(2)
       NPX3=NPIX(3)
       DO 6000 I5=1,NSYM
       READ(2,27)(IIR(I5,J),J=1,9),(IIT(I5,J1),J1=1,3)
       WRITE(3,27)(IIR(I5,J),J=1,9),(IIT(I5,J1),J1=1,3)
27     FORMAT(12I5)
6000   CONTINUE
       DO 6666 I5=1,NSYM
       DO 333 J=1,9
       R(I5,J)=FLOAT(IIR(I5,J))
333    CONTINUE
       DO 777 J1=1,3
       T(I5,J1)=FLOAT(IIT(I5,J1))
777    CONTINUE
6666   CONTINUE
       WRITE(6,277)((R(I5,J),J=1,9),(T(I5,J1),J1=1,3),I5=1,NSYM)
277    FORMAT(12F6.2)
       DO 1010 I=1,NASYM
       IF(NPX1.EQ.0.OR.NPX2.EQ.0.OR.NPX3.EQ.0)GO TO 1010
       AIASYM(1,I)=IASYM(1,I)/FLOAT(NPX1)
       AIASYM(2,I)=IASYM(2,I)/FLOAT(NPX2)
       AIASYM(3,I)=IASYM(3,I)/FLOAT(NPX3)
1010   CONTINUE
       READ(2,28)((ISUB(I7,K),I7=1,3),K=1,NSUB)
       WRITE(3,28)((ISUB(I7,K),I7=1,3),K=1,NSUB)
28     FORMAT(3I5)
       CELL(4)=CELL(4)*PHI/180.0
       CELL(5)=CELL(5)*PHI/180.0
       CELL(6)=CELL(6)*PHI/180.0
        READ(2,*)NR
        WRITE(6,*)NR
        DO 100 I=1,NR
        READ(2,*)(RR(I,J),J=1,9),(TR(I,J),J=1,3)
        WRITE(6,1020)(RR(I,J),J=1,9),(TR(I,J),J=1,3)
 1020   FORMAT(1x,9F6.2,1X,3F5.2)
 100    CONTINUE
      DO 700 IX=1,NPX1
      DO 700 IY=1,NPX2
      DO 700 IZ=1,NPX3
      XJX(IX,IY,IZ)=0.0
      KX(IX,IY,IZ)=0
  700 CONTINUE
      NCOUNT=0
      STEP1=1.0/NPX1
      STEP2=1.0/NPX2
      STEP3=1.0/NPX3
      DO 1000 I=1,NASYM
      NXX=INT(AIASYM(1,I)/STEP1)+1
      NYY=INT(AIASYM(2,I)/STEP2)+1
      NZZ=INT(AIASYM(3,I)/STEP3)+1
      XJX(NXX,NYY,NZZ)=RDEN(I)
      NCOUNT=NCOUNT+1
      KX(NXX,NYY,NZZ)=1
      DO 110 IR=1,NR
      DO 120 IM=1,3
      K=3*(IM-1)+1
      RL(IR,IM)=RR(IR,K)*AIASYM(1,I)+RR(IR,K+1)*AIASYM(2,I)+RR(IR,K+2)*
     *AIASYM(3,I)+TR(IR,IM)
      IF (RL(IR,IM).GE.0.0) GO TO 20
      RL(IR,IM)=RL(IR,IM)+1.0
      GO TO 120
 20   CONTINUE
       IF(RL(IR,IM).GE.1.0) RL(IR,IM)=RL(IR,IM)-1.0
  120 CONTINUE 
       IXX=INT(RL(IR,1)/STEP1)+1
       IYY=INT(RL(IR,2)/STEP2)+1
       IZZ=INT(RL(IR,3)/STEP3)+1  
       IF(KX(IXX,IYY,IZZ).GE.1) GO TO 110
       XJX(IXX,IYY,IZZ)=RDEN(I)
       NCOUNT=NCOUNT+1  
       KX(IXX,IYY,IZZ)=1
110    CONTINUE
1000   CONTINUE
       DO 3390 I1=2,NPX1
       DO 3390 J1=2,NPX2
       XJX(I1,J1,NPX3)=XJX(I1,J1,1)
       NCOUNT=NCOUNT+1
 3390  CONTINUE    
       DO 3391 I2=2,NPX1
       DO 3391 K2=2,NPX3
       XJX(I2,NPX2,K2)=XJX(I2,1,K2)
       NCOUNT=NCOUNT+1
 3391 CONTINUE
       DO 3392 J3=2,NPX2
       DO 3392 K3=2,NPX3
       XJX(NPX1,J3,K3)=XJX(1,J3,K3)
       NCOUNT=NCOUNT+1
 3392 CONTINUE
       DO 5390 I1=2,NPX1
       XJX(I1,1,NPX3)=XJX(I1,1,1)
       NCOUNT=NCOUNT+1
 5390 CONTINUE    
       DO 5391 K2=2,NPX2
       XJX(1,K2,NPX3)=XJX(1,K2,1)
       NCOUNT=NCOUNT+1
 5391 CONTINUE
       DO 5392 J3=2,NPX2
       XJX(NPX1,J3,1)=XJX(1,J3,1)
       NCOUNT=NCOUNT+1
 5392 CONTINUE
        DO 5393 I2=2,NPX2
       XJX(NPX1+1,I2,NPX3+1)=XJX(1,I2,1)
       NCOUNT=NCOUNT+1
 5393 CONTINUE    
       DO 5394 I3=2,NPX1
       XJX(I3,NPX2+1,1)=XJX(I3,1,1)
       NCOUNT=NCOUNT+1
 5394 CONTINUE
       DO 5395 J1=2,NPX3
       XJX(NPX1+1,1,J1)=XJX(1,1,J1)
       NCOUNT=NCOUNT+1
 5395 CONTINUE
        DO 5396 I4=2,NPX3
       XJX(1,NPX2+1,I4)=XJX(1,1,I4)
       NCOUNT=NCOUNT+1
 5396 CONTINUE    
       DO 5397 I5=2,NPX3
       XJX(NPX1+1,NPX2+1,I5)=XJX(1,1,I5)
       NCOUNT=NCOUNT+1
 5397 CONTINUE
       DO 5398 J2=2,NPX1
       XJX(J2,NPX2+1,NPX3+1)=XJX(J2,1,1)
       NCOUNT=NCOUNT+1
 5398 CONTINUE
       XJX(1,1,NPX3+1)=XJX(1,1,1)
       XJX(1,NPX2+1,1)=XJX(1,1,1)
       XJX(NPX1+1,1,1)=XJX(1,1,1)
       XJX(1,NPX2+1,NPX3+1)=XJX(1,1,1)
       XJX(NPX1+1,1,NPX3+1)=XJX(1,1,1)
       XJX(NPX1+1,NPX2+1,1)=XJX(1,1,1)
       XJX(NPX1+1,NPX2+1,NPX3+1)=XJX(1,1,1)
       NCOUNT=NCOUNT+7
       DO 4203 IX=1,NPX3+1
       X=SQRT((CELL(1)*STEP1)**2+(CELL(2)*STEP2)**2+(CELL(3)*STEP3)**
     *2)*REAL(IX-1)
       WRITE(12,1002) X,XJX(IX,IX,IX)
 1002  FORMAT(1X,F10.7,E14.6)
 4203  CONTINUE
       DO 4211 IX1=1,NPX2+1
       X=SQRT((CELL(1)*STEP1)**2+(CELL(2)*STEP2)**2)*REAL(IX1-1)
       WRITE(9,1002) X,XJX(IX1,IX1,1)
4211   CONTINUE
       DO 4215 IX1=1,NPX3+1
       X=SQRT((CELL(2)*STEP2)**2+(CELL(3)*STEP3)**2)*REAL(IX1-1)
       WRITE(10,1002) X,XJX(1,IX1,IX1)
4215   CONTINUE
       DO 4216 IX1=1,NPX1+1
       X=SQRT((CELL(3)*STEP3)**2+(CELL(1)*STEP1)**2)*REAL(IX1-1)
       WRITE(11,1002) X,XJX(IX1,1,IX1)
4216   CONTINUE
       DO 4212 IX2=1,NPX1+1
       X=CELL(1)*STEP1*REAL(IX2-1)
       WRITE(4,1002) X,XJX(IX2,1,1)
4212   CONTINUE
       DO 4213 IX2=1,NPX2+1
       X=CELL(2)*STEP2*REAL(IX2-1)
       WRITE(7,1002) X,XJX(1,IX2,1)
4213   CONTINUE
       DO 4214 IX2=1,NPX3+1
       X=CELL(3)*STEP3*REAL(IX2-1)
       WRITE(8,1002) X,XJX(1,1,IX2)
4214   CONTINUE
       CLOSE(2)
       CLOSE(3)
       CLOSE(4)
       CLOSE(7)
       CLOSE(8)
       CLOSE(9)
       CLOSE(10)
       CLOSE(11)
       CLOSE(12)
       STOP
       END
